import es
from time import time
import gamethread

delaybetweenuses = 10 # time between allowed uses
blocktime = 5 # time they get block
usesperround = 3


plydict = {}

def player_spawn(event_var):
    userid = int(event_var["userid"])
    es.setplayerprop(userid,"CBaseEntity.m_CollisionGroup",2)
    if userid in plydict:
        plydict[userid]["lastuse"] = 0
        plydict[userid]["usesthisround"] = 0

    
def player_say(event_var):
    userid = int(event_var["userid"])
    text = event_var["text"]
    if text == "!block":
        if userid not in plydict:
            plydict[userid] = {}
            plydict[userid]["lastuse"] = time()
            plydict[userid]["usesthisround"] = 1
            es.tell(userid,"You are now blocking")
            es.setplayerprop(event_var["userid"],"CBaseEntity.m_CollisionGroup",0)
        elif time()-plydict[userid]["lastuse"] >= delaybetweenuses:
            if plydict[userid]["usesthisround"] == usesperround:
                es.tell(userid,"You cant use !block anymore this round")
            else:
                plydict[userid]["lastuse"] = time()
                plydict[userid]["usesthisround"] += 1
                es.tell(userid,"You are now blocking")
                es.setplayerprop(event_var["userid"],"CBaseEntity.m_CollisionGroup",0)
                gamethread.delayed(blocktime,unblock,userid)
        else:
            es.tell(userid,"You have to wait another %.2f seconds." % (delaybetweenuses-(time()-plydict[userid]["lastuse"])))
            
def unblock(userid):
    es.setplayerprop(event_var["userid"],"CBaseEntity.m_CollisionGroup",2)
    es.tell(userid,"You dont block anymore")

def load():
    sendMessage()

def es_map_start(ev):
    sendMessage()

def sendMessage():
    gamethread.cancelDelayed('Type !block for getting block for 10 sec')
    es.msg('Type !block for getting block for 10 sec')
    gamethread.delayedname(300,'Type !block for getting block for 10 sec',sendMessage)

def unload():
    gamethread.cancelDelayed('Type !block for getting block for 10 sec')